#version 330 core
layout (location = 0) in vec3 position;
layout (location = 1) in vec3 normal;
layout (location = 2) in vec2 uv;

out vec3 fragNormal;
out vec2 fragmentUV;
out vec3 FragPos;

uniform mat4 model;
uniform mat4 VP;

uniform bool reverse_normals;

void main()
{
    FragPos = vec3(model * vec4(position, 1.0));
    if(reverse_normals) // a slight hack to make sure the outer large cube displays lighting from the 'inside' instead of the default 'outside'.
        fragNormal = transpose(inverse(mat3(model))) * (-1.0 * normal);
    else
        fragNormal = transpose(inverse(mat3(model))) * normal;
    fragmentUV = uv;
    gl_Position = VP * model * vec4(position, 1);
}